pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT > Class Template Reference
Module features

UniqueShapeContext implements the Unique Shape Context Descriptor described here: More...

`#include <pcl/features/usc.h>`

Inheritance diagram for pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >:

## Public Types

typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Feature< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef boost::shared_ptr< UniqueShapeContext< PointInT, PointOutT, PointRFT > > | Ptr
typedef boost::shared_ptr< const UniqueShapeContext< PointInT, PointOutT, PointRFT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr
Public Types inherited from pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >
typedef pcl::PointCloud< PointRFT > | PointCloudLRF
typedef PointCloudLRF::Ptr | PointCloudLRFPtr
typedef PointCloudLRF::ConstPtr | PointCloudLRFConstPtr

## Public Member Functions

| UniqueShapeContext ()
| Constructor. More...
virtual | ~UniqueShapeContext ()
size_t | getAzimuthBins () const
size_t | getElevationBins () const
size_t | getRadiusBins () const
void | setMinimalRadius (double radius)
| The minimal radius value for the search sphere (rmin) in the original paper. More...
double | getMinimalRadius () const
void | setPointDensityRadius (double radius)
| This radius is used to compute local point density density = number of points within this radius. More...
double | getPointDensityRadius () const
void | setLocalRadius (double radius)
| Set the local RF radius value. More...
double | getLocalRadius () const
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...
Public Member Functions inherited from pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >
| FeatureWithLocalReferenceFrames ()
| Empty constructor. More...
virtual | ~FeatureWithLocalReferenceFrames ()
| Empty destructor. More...
void | setInputReferenceFrames (const PointCloudLRFConstPtr &frames)
| Provide a pointer to the input dataset that contains the local reference frames of the XYZ dataset. More...
PointCloudLRFConstPtr | getInputReferenceFrames () const
| Get a pointer to the local reference frames. More...

## Protected Member Functions

void | computePointDescriptor (size_t index, std::vector< float > &desc)
| Compute 3D shape context feature descriptor. More...
virtual bool | initCompute ()
| Initialize computation by allocating all the intervals and the volume lookup table. More...
virtual void | computeFeature (PointCloudOut &output)
| The actual feature computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Member Functions inherited from pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >
virtual bool | initLocalReferenceFrames (const size_t &indices_size, const LRFEstimationPtr &lrf_estimation=LRFEstimationPtr())

## Protected Attributes

std::vector< float > | radii_interval_
| values of the radii interval. More...
std::vector< float > | theta_divisions_
| Theta divisions interval. More...
std::vector< float > | phi_divisions_
| Phi divisions interval. More...
std::vector< float > | volume_lut_
| Volumes look up table. More...
size_t | azimuth_bins_
| Bins along the azimuth dimension. More...
size_t | elevation_bins_
| Bins along the elevation dimension. More...
size_t | radius_bins_
| Bins along the radius dimension. More...
double | min_radius_
| Minimal radius value. More...
double | point_density_radius_
| Point density radius. More...
size_t | descriptor_length_
| Descriptor length. More...
double | local_radius_
| Radius to compute local RF. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
Protected Attributes inherited from pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >
PointCloudLRFConstPtr | frames_
| A boost shared pointer to the local reference frames. More...
bool | frames_never_defined_
| The user has never set the frames. More...

## Additional Inherited Members

Protected Types inherited from pcl::FeatureWithLocalReferenceFrames< PointInT, PointRFT >
typedef Feature< PointInT, PointRFT >::Ptr | LRFEstimationPtr
| Check if frames_ has been correctly initialized and compute it if needed. More...

## Detailed Description

### template<typename PointInT, typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>
class pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >

UniqueShapeContext implements the Unique Shape Context Descriptor described here:

- F. Tombari, S. Salti, L. Di Stefano, "Unique Shape Context for 3D data description", International Workshop on 3D Object Retrieval (3DOR 10) - in conjuction with ACM Multimedia 2010

The suggested PointOutT is pcl::ShapeContext1980

Author
  Alessandro Franchi, Federico Tombari, Samuele Salti (original code)
  Nizar Sallem (port to PCL)

Definition at line 64 of file usc.h.

## Member Typedef Documentation

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

typedef boost::shared_ptr<const UniqueShapeContext<PointInT, PointOutT, PointRFT> > pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::ConstPtr

Definition at line 82 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

typedef Feature<PointInT, PointOutT>::PointCloudIn pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::PointCloudIn

Definition at line 80 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::PointCloudOut

Definition at line 79 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

typedef boost::shared_ptr<UniqueShapeContext<PointInT, PointOutT, PointRFT> > pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::Ptr

Definition at line 81 of file usc.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::UniqueShapeContext | ( |  | ) |

inline

Constructor.

Definition at line 86 of file usc.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, and pcl::Feature< PointInT, PointOutT >::search_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

virtual pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::~UniqueShapeContext | ( |  | ) |

inline virtual

Definition at line 95 of file usc.h.

## Member Function Documentation

template<typename PointInT , typename PointOutT , typename PointRFT >

void pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

The actual feature computation.

Parameters

  [out] | output | the resultant features

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 247 of file usc.hpp.

References pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getLocalRadius().

template<typename PointInT , typename PointOutT , typename PointRFT >

void pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computePointDescriptor | ( | size_t | index,
|  | std::vector< float > & | desc
| ) |  |

protected

Compute 3D shape context feature descriptor.

Parameters

  [in] | index | point index in input_
  [out] | desc | descriptor to compute

Compute the angle between the neighbour and the z axis (normal) in the interval [0, 180]

Bin (j, k, l)

Compute the Bin(j, k, l) coordinates of current neighbour

Local point density = number of points in a sphere of radius "point_density_radius_" around the current neighbour

point_density is always bigger than 0 because FindPointsWithinRadius returns at least the point itself

Accumulate w into correspondant Bin(j,k,l)

Definition at line 144 of file usc.hpp.

References pcl::utils::equal(), pcl::geometry::project(), and pcl::rad2deg().

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getLocalRadius().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getAzimuthBins | ( |  | ) | const

inline

Returns
  The number of bins along the azimuth.

Definition at line 102 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::azimuth_bins_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getElevationBins | ( |  | ) | const

inline

Returns
  The number of bins along the elevation

Definition at line 109 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::elevation_bins_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getLocalRadius | ( |  | ) | const

inline

Returns
  The local RF radius.

Definition at line 147 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computeFeature(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::computePointDescriptor(), pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::initCompute(), and pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::local_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getMinimalRadius | ( |  | ) | const

inline

Returns
  The minimal sphere radius.

Definition at line 126 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::min_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getPointDensityRadius | ( |  | ) | const

inline

Returns
  The point density search radius.

Definition at line 137 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::point_density_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getRadiusBins | ( |  | ) | const

inline

Returns
  The number of bins along the radii direction.

Definition at line 116 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::radius_bins_.

template<typename PointInT , typename PointOutT , typename PointRFT >

bool pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::initCompute | ( |  | ) |

protected virtual

Initialize computation by allocating all the intervals and the volume lookup table.

Reimplemented from pcl::Feature< PointInT, PointOutT >.

Definition at line 52 of file usc.hpp.

References pcl::deg2rad(), pcl::PCLBase< PointInT >::setIndices(), pcl::PCLBase< PointInT >::setInputCloud(), pcl::Feature< PointInT, PointOutT >::setRadiusSearch(), and pcl::Feature< PointInT, PointOutT >::setSearchSurface().

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getLocalRadius().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

void pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setLocalRadius | ( | double | radius | ) |

inline

Set the local RF radius value.

Parameters

  [in] | radius | the desired local RF radius

Definition at line 143 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::local_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

void pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setMinimalRadius | ( | double | radius | ) |

inline

The minimal radius value for the search sphere (rmin) in the original paper.

Parameters

  [in] | radius | the desired minimal radius

Definition at line 122 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::min_radius_.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

void pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setPointDensityRadius | ( | double | radius | ) |

inline

This radius is used to compute local point density density = number of points within this radius.

Parameters

  [in] | radius | Value of the point density search radius

Definition at line 133 of file usc.h.

References pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::point_density_radius_.

## Member Data Documentation

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::azimuth_bins_

protected

Bins along the azimuth dimension.

Definition at line 180 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getAzimuthBins().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::descriptor_length_

protected

Descriptor length.

Definition at line 195 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::elevation_bins_

protected

Bins along the elevation dimension.

Definition at line 183 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getElevationBins().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::local_radius_

protected

Radius to compute local RF.

Definition at line 198 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getLocalRadius(), and pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setLocalRadius().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::min_radius_

protected

Minimal radius value.

Definition at line 189 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getMinimalRadius(), and pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setMinimalRadius().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

std::vector<float> pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::phi_divisions_

protected

Phi divisions interval.

Definition at line 174 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

double pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::point_density_radius_

protected

Point density radius.

Definition at line 192 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getPointDensityRadius(), and pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::setPointDensityRadius().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

std::vector<float> pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::radii_interval_

protected

values of the radii interval.

Definition at line 168 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

size_t pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::radius_bins_

protected

Bins along the radius dimension.

Definition at line 186 of file usc.h.

Referenced by pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::getRadiusBins().

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

std::vector<float> pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::theta_divisions_

protected

Theta divisions interval.

Definition at line 171 of file usc.h.

template<typename PointInT , typename PointOutT = pcl::ShapeContext1980, typename PointRFT = pcl::ReferenceFrame>

std::vector<float> pcl::UniqueShapeContext< PointInT, PointOutT, PointRFT >::volume_lut_

protected

Volumes look up table.

Definition at line 177 of file usc.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/usc.h
- /build/pcl-6_P28C/pcl-1.7.2/features/include/pcl/features/impl/usc.hpp